#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>

#define SERIAL_PORT     "/dev/ttyAM1"

int main(){
  int fd;
  fd = open(SERIAL_PORT, O_RDWR | O_NOCTTY);
  if(fd < 0){
    printf("%s doesn't open it\n",SERIAL_PORT);
    return -1;
  }

  struct termios oldtio, newtio;
  tcgetattr(fd, &oldtio);
  newtio = oldtio;

  newtio.c_iflag = IGNPAR;
  /* JmjJ͏ */
  newtio.c_lflag = 0;

  /* read֐ł̕҂̐ݒ */
  newtio.c_cc[VTIME] = 0; /* lx0.1b҂ */
  newtio.c_cc[VMIN] = 1; /* l͂̕܂ő҂*/

  /* obt@NA */
  tcflush(fd, TCIFLUSH);
  
  cfsetspeed(&newtio, B9600);
  tcsetattr(fd, TCSANOW, &newtio);

  /* {[h̐ݒ */
  int id=120;

  int i, j, k;
  unsigned char command[4] = {255, id, 1, 1};
  unsigned char data[20];
  
  for(i=1 ; i<=10 ; i++){
    printf("Getting data : %d\n", i);

    /* ZT{[hɃf[^v */
    write(fd, command, sizeof(command));
    /* 1ڃf[^M */
    read(fd, &data[0], 1);
    if(data[0] == 255){
      read(fd, &data[1], 1);
      if(data[1] == id){
        read(fd, &data[2], 1);
        if(data[2] == 17){
          read(fd, &data[3], 1);
          if(data[3] == 1){
            for(k=4 ; k<20 ; k++){
              /* read(fd, data2, 16);Ƃ */
              read(fd, &data[k], 1);
              printf("port %2d : data = %d\n", k-3, data[k]);
            }
          }
        }
      }
    }
  }

  for(i=1 ; i<=100 ; i++){
    printf("Getting data : %d :", i);

    /* ZT{[hɃf[^v */
    write(fd, command, sizeof(command));
    usleep(100000);
    /* 1ڃf[^M */
    read(fd, &data[0], 1);
    if(data[0] == 255){
      read(fd, &data[1], 1);
      if(data[1] == id){
        read(fd, &data[2], 1);
        if(data[2] == 17){
          read(fd, &data[3], 1);
          if(data[3] == 1){
            for(k=4 ; k<20 ; k++){
              /* read(fd, data2, 16);Ƃ */
              read(fd, &data[k], 1);
            }

            for(k=4 ; k<7 ; k++){
              /* read(fd, data2, 16);Ƃ */
              printf("data = %d :", data[k]);
            }
            printf("\n");
          }
        }
      }
    }
  }

  tcsetattr(fd, TCSANOW, &oldtio);
  close(fd);
  return 0;
}
